def comparar_int(a,b):
	return a - b
def comparar_str(a,b):
	if(a == b): return 0
	if(a < b): return -1
	if(a > b): return 1

# a y b => ((año,mes,día),(país,ciudad))
def comparar(a,b):
	# Primero comparo según fecha
	for i in range(3):
		if(a[0][i] != b[0][i]):
			return comparar_int(a[0][i],b[0][i])
	# Luego comparo nombres ciudades
	for i in range(2):
		if(a[1][i] != b[1][i]):
			return comparar_str(a[1][i],b[1][i])
	# Si llego aquí son iguales
	return 0


def insertSort(l):
	# Recorro los elementos de l a partir de 1
	for i in range(1,len(l)):
		# Guardo valor y posición actual
		aux = l[i]
		j = i
		# Mientras el elemento de la izquierda sea menor lo intercambio por j
		while(j>0 and comparar(aux,l[j-1])<0):#aux<l[j-1]
			l[j] = l[j-1]
			j -= 1
		l[j] = aux

	# Retornamos lista ordenada
	return l

def bs_r(l,e,i,j):
	# Caso base
	if(i > j):
		return False
	# Llamado recursivo
	n = (i + j) // 2
	if(comparar(e,l[n]) < 0):    # e < l[n]
		return bs_r(l,e,i,n-1)
	elif(comparar(e,l[n]) > 0):  # e > l[n]
		return bs_r(l,e,n+1,j)
	else:                        # e == l[n]
		return True

def binary_search(l,e):
	return bs_r(l,e,0,len(l)-1)


vuelos = [
  ((2014,1,2),('Peru','Lima')),
	((2014,1,2),('Costa Rica','San Jose')),
	((2014,1,2),('USA','Los Angeles')),
	((2014,1,2),('Panama','C. de Panama')),
  ((2014,1,3),('Brasil','Sao Paulo')),
	((2014,1,3),('Costa Rica','San Jose')),
  ((2014,5,1),('Peru','Lima')),
	((2014,5,1),('Costa Rica','San Jose')),
	((2014,5,1),('Argentina', 'Buenos Aires'))]
print(insertSort(vuelos))
print(binary_search(vuelos,((2014,5,1),('Argentina', 'Buenos Aires'))))
print(binary_search(vuelos,((2014,5,1),('Brasil','Sao Paulo'))))
